# -*- coding: utf-8 -*-
# Generated by Django 1.11.6 on 2018-03-20 19:23
from __future__ import unicode_literals

from django.db import migrations
from django.db.migrations import RunPython

def create_rangediscount_email_template(apps, schema_editor):
    template_model = apps.get_model('customer', 'CommunicationEventType')
    variable_model = apps.get_model('customer', 'CommunicationEventTypeTestVariable')

    comm_event_types = [
        {
            'code': 'SUBSCRIPTION_FOR_DISCOUNT',
            'name': 'Подписка на скидку',
            'variables': [
                {
                    'code': 'discount.name',
                    'description': 'наименование скидки'
                },
                {
                    'code': 'discount.rules',
                    'description': 'условия участия в акции'
                },
                {
                    'code': 'discount.type',
                    'description': 'тип (Percentage/Absolute)'
                },
                {
                    'code': 'discount.value',
                    'description': 'значение'
                },
                {
                    'code': 'discount.end_datetime',
                    'description': 'время окончания'
                },
                {
                    'code': 'phone_number',
                    'description': 'номер телефона клиента'
                },
                {
                    'code': 'email',
                    'description': 'электронная почта клиента'
                },
                {
                    'code': 'name',
                    'description': 'имя клиента'
                },
                {
                    'code': 'product.title',
                    'description': 'название товара'
                }
            ]
        },
    ]

    for comm_event_type in comm_event_types:
        try:
            template = template_model.objects.get(code=comm_event_type['code'])
        except template_model.DoesNotExist:
            template = template_model.objects.create(
                name=comm_event_type['name'],
                code=comm_event_type['code']
            )
        for variable in comm_event_type['variables']:
            variable_model.objects.create(
                template=template,
                code=variable['code'],
                description=variable['description'],
            )


def remove_rangediscount_email_template(apps, schema_editor):
    template_model = apps.get_model('customer', 'CommunicationEventType')
    try:
        subscription = template_model.get(code='SUBSCRIPTION_FOR_DISCOUNT')
    except template_model.DoesNotExist:
        pass
    else:
        subscription.delete()


class Migration(migrations.Migration):
    dependencies = [
        ('offer', '0036_remove_rangediscount_start_datetime'),
    ]

    operations = [
        RunPython(create_rangediscount_email_template, remove_rangediscount_email_template)
    ]
